property desc : "Drop one or more files on my application icon to change their creators and/or types.

Copyright  1996, 1997 Christopher E. Hyde.
All rights reserved.
Email: drjekyll@hylight.demon.co.uk"
property txt : "TEXT"
property appList : ["MPW", "ToolServer", "SPM", "BBEdit", "Simple Text", "Claris Works", "MS Word", "ResEdit", "Other:", 
	"Script Editor"] -- Append up to 8 more application/creator/types
property cList : ["MPS ", "MPSX", "SPM ", "R*ch", "ttxt", "BOBO", "MSWD", "RSED", null, "ToyS", 11, 12, 13, 14, 15, 16, 17, 18]
property tList : [txt, txt, txt, txt, txt, txt, txt, "rsrc", null, txt]
property opt : 3
property doCreat : true
property doType : true

on open fileList
	dd install with greyscale
	set f to item 1 of fileList
	tell application "Finder"
		set c to creator type of f
		set t to file type of f
	end tell
	set dlog to {size:[260, 330], contents:[
		{class:push button, bounds:[190, 300, 250, 320], name:"OK"}, 
		{class:push button, bounds:[110, 300, 170, 320], name:"Cancel"}, 
		{class:radio group, bounds:[10, 60, 120, 76], button offset:[120, 20], max down:9, value:opt, contents:appList}, 
		{class:text field, name:"Creator", name bounds:[30, 240, 85, 256], bounds:[90, 240, 140, 256], value:c, enabled:[dAnd, Sub(3, 9), 8]}, 
		{class:text field, name:"Type", name bounds:[155, 240, 190, 256], bounds:[195, 240, 245, 256], value:t, enabled:[dAnd, Sub(3, 9), 9]}, 
		{class:group box, bounds:[8, 8, 252, 40], style:secondary group}, 
		{class:static text, bounds:[12, 12, 248, 36], font:{name:"Geneva", size:9}, contents:
			"Change the file creators and/or types of the " & (fileList's length) & " files that were dropped on me."}, 
		{class:check box, bounds:[30, 265, 140, 281], name:"Set Creator", value:doCreat}, 
		{class:check box, bounds:[155, 265, 260, 281], name:"Set Type", value:doType} 
			], name:"Set File Creator & Type", style:movable modal}
	set dVals to dd auto dialog dlog with greyscale
	if item 1 of dVals then
		set opt to item 3 of dVals
		if opt = 9 then
			set c to item 4 of dVals
			set t to item 5 of dVals
		else
			set c to item opt of cList
			set t to item opt of tList
		end if
		set doCreat to item 8 of dVals
		set doType to item 9 of dVals
		tell application "Finder"
			repeat with f in fileList
				if doCreat then set creator type of f to c
				if doType then set file type of f to t
			end repeat
		end tell
	end if
	if (dd count dialogs) = 0 then quit
end open

on run
	dd install with greyscale
	set dlog to {size:[260, 130], contents:[
		{class:group box, bounds:[8, 8, 252, 44], style:tertiary group}, 
		{class:static text, contents:"Set File Creators & Types
Dialog Director v0.6 Demonstration", bounds:[10, 10, 250, 42], justification:center}, 
		{class:static text, font:{name:"Geneva", size:9}, contents:desc, bounds:[10, 48, 240, 48 + 72]} 
			], name:"Super Creator/Type", style:document window}
	dd make dialog dlog
end run

on idle
	dd interact with user for max ticks 0
	return 1
end idle

on quit
	try
		dd uninstall
	on error
	end try
	continue quit
end quit

on Sub(group, btn)
	return group + btn * 256
end Sub